require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__LINUX_RCUPDATE_H)) {
    eval 'sub __LINUX_RCUPDATE_H () {1;}' unless defined(&__LINUX_RCUPDATE_H);
    if(defined(&__KERNEL__)) {
	require 'linux/cache.ph';
	require 'linux/spinlock.ph';
	require 'linux/threads.ph';
	require 'linux/percpu.ph';
	require 'linux/cpumask.ph';
	require 'linux/seqlock.ph';
	eval 'sub RCU_HEAD_INIT {
	    local($head) = @_;
    	    eval q({ . &next =  &NULL, . &func =  &NULL });
	}' unless defined(&RCU_HEAD_INIT);
	eval 'sub RCU_HEAD {
	    local($head) = @_;
    	    eval q(\'struct rcu_head\' $head =  &RCU_HEAD_INIT($head));
	}' unless defined(&RCU_HEAD);
	eval 'sub INIT_RCU_HEAD {
	    local($ptr) = @_;
    	    eval q( &do { ($ptr)-> &next =  &NULL; ($ptr)-> &func =  &NULL; }  &while (0));
	}' unless defined(&INIT_RCU_HEAD);
	eval 'sub RCU_quiescbatch {
	    local($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &quiescbatch));
	}' unless defined(&RCU_quiescbatch);
	eval 'sub RCU_qsctr {
	    local($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &qsctr));
	}' unless defined(&RCU_qsctr);
	eval 'sub RCU_last_qsctr {
	    local($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &last_qsctr));
	}' unless defined(&RCU_last_qsctr);
	eval 'sub RCU_qs_pending {
	    local($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &qs_pending));
	}' unless defined(&RCU_qs_pending);
	eval 'sub RCU_batch {
	    local($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &batch));
	}' unless defined(&RCU_batch);
	eval 'sub RCU_nxtlist {
	    local($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &nxtlist));
	}' unless defined(&RCU_nxtlist);
	eval 'sub RCU_curlist {
	    local($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &curlist));
	}' unless defined(&RCU_curlist);
	eval 'sub RCU_nxttail {
	    local($cpu) = @_;
    	    eval q(( &per_cpu( &rcu_data, ($cpu)). &nxttail));
	}' unless defined(&RCU_nxttail);
	eval 'sub rcu_pending {
	    local($cpu) = @_;
    	    eval q({  &if ( &RCU_curlist($cpu)  && ! &rcu_batch_before( ($rcu_ctrlblk->{completed}), &RCU_batch($cpu))) 1;  &if (! &RCU_curlist($cpu)  &&  &RCU_nxtlist($cpu)) 1;  &if ( &RCU_quiescbatch($cpu) !=  ($rcu_ctrlblk->{cur}) ||  &RCU_qs_pending($cpu)) 1; 0; });
	}' unless defined(&rcu_pending);
	eval 'sub rcu_read_lock () {
	    eval q( &preempt_disable());
	}' unless defined(&rcu_read_lock);
	eval 'sub rcu_read_unlock () {
	    eval q( &preempt_enable());
	}' unless defined(&rcu_read_unlock);
    }
}
1;
